USE AdventureWorks2012;
GO
SET STATISTICS IO ON;
SET STATISTICS TIME ON;

-- Simple example to show performance difference.
SELECT   SalesOrderID, SalesOrderDetailID, LineTotal,
         SUM(LineTotal) OVER (ORDER BY SalesOrderID, SalesOrderDetailID
                              ROWS BETWEEN UNBOUNDED PRECEDING AND CURRENT ROW) AS RunningTotal
INTO     #Oblivion                      -- Remove overhead of SSMS rendering results
FROM     Sales.SalesOrderDetail
ORDER BY SalesOrderID, SalesOrderDetailID;

DROP TABLE #Oblivion;
GO

SELECT   SalesOrderID, SalesOrderDetailID, LineTotal,
         SUM(LineTotal) OVER (ORDER BY SalesOrderID, SalesOrderDetailID
                              RANGE BETWEEN UNBOUNDED PRECEDING AND CURRENT ROW) AS RunningTotal
INTO     #Oblivion                      -- Remove overhead of SSMS rendering results
FROM     Sales.SalesOrderDetail
ORDER BY SalesOrderID, SalesOrderDetailID;

DROP TABLE #Oblivion;
GO

-- The performance penalty for saving some keystrokes
SELECT   SalesOrderID, SalesOrderDetailID, LineTotal,
         SUM(LineTotal) OVER (ORDER BY SalesOrderID, SalesOrderDetailID) AS RunningTotal
INTO     #Oblivion                      -- Remove overhead of SSMS rendering results
FROM     Sales.SalesOrderDetail
ORDER BY SalesOrderID, SalesOrderDetailID;

DROP TABLE #Oblivion;
GO
